; asmsyntax=asmM68k
; Mand.asm mandPlotter, in Pila, for Palm m100

	appl "mandAsm",'demo'

	include "pilot.inc"
	include "startup.inc"

; TODO: hardware-reg equ file...
; LCD controller regs
rLPICF 	equ $A20
rLVPW  	equ $A05
rLSSA	equ $A00

dREG equ $FFFFF000 ; DragonBall regs

	data
; a5 based global vars:
cr0	dc.w -2<<8
ci0	dc.w -2<<8
dx	dc.w (3<<8)/160
dy	dc.w (3<<8)/160

	code

proc drawMand()
beginproc
	move.l dREG|rLSSA,a0          ;  re-read screen pointer
	; ^ should compile to a 'short' abs load
	move.w #160-1,d7
	move.w ci0(a5),a3
.y
	swap d7
	move.w #$A0-1,d7
	move.w cr0(a5),a2   ; ( c = 'a2'+i'a3' )
.x
	; d0,d1,d2,d3 = (a,b,a^2,b^2) [ z = a+ib, z^2 = (a^2-b^2)+i2ab ]
	; we chk the escape time from z(n)=z(n-1)^2+c
	move.w #16,d6 ; colour counter
	clr.w d0
	clr.w d1
.mLoop
	move.w d0,d2
	muls d2,d2
	asr.l #8,d2
	move.w d1,d3
	muls d3,d3
	asr.l #8,d3

	muls d0,d1
	asl.l #7,d1 
	add.w a3,d1 ; = 2ab + im

	move.w d2,d0
	sub.w d3,d0
	add.w a2,d0 ; = (a^2-b^2) + re

	add.w d2,d3 ; = norm
	cmp.w #4<<8,d3 ; maxNorm
	dbge d6,.mLoop

	subq #1,d7
	btst #1,d7
	beq .second
	lsl.b #4,d6
	move.b d6,d5 ; save pix value
	bra .s0
.second
	and.b #$0f,d6
	or.b d6,d5
	move.b d5,(a0)+
.s0

	add.w #(3<<8)/160,a2
	dbra d7,.x
	add.w #(3<<8)/160,a3
	swap d7
	dbra d7,.y

endproc ; drawMand

proc drawMand1()
beginproc
	move.l dREG|rLSSA,a0     ; a0 -> vid
	move.w #160-1,d7          ; ypix cnt
	move.w ci0(a5),a4       ; imPart

.yLoop:
	swap d7 ;  also xpixcnt
	move.w #160-1,d7       ; xpixcnt
	move.w cr0(a5),a3       ; rePart

.xLoop:
	clr.w d0      ; a
	clr.w d1      ; b
	move.b #16,d6      ; colour
;	clr.b d5 ; pixel
	clr.b d4 ; mode (0/1)

.mLoop:
; d0,d1,d2,d3 = a,b,a2,b2
	move.w d0,d2 ; dup val for ^2
	muls.w d2,d2
	asr.l #8,d2   ; 8.8 fixed point

	move.w d1,d3
	muls.w d3,d3
	asr.l #8,d3

	muls.w d0,d1
	asr.l #7,d1
	add.w a4,d1

	move.w d2,d0
	sub.w d3,d0
	add.w a3,d0

	add.w d2,d3
	cmp.w #4<<8,d3
	; incr colour and tst
	dbge d6,.mLoop
	; put the pixel:
	tst.b d4
	bne .mode1
	add.b #01,d6
	move.b d6,d5
	lsl.b #4,d5
	addq.b #1,d4
	bra .s0
.mode1:
	add.b #01,d6
	or.b d6,d5
	move.b d5,(a0)+
	subq.b #1,d4
.s0
	
; incr-rePart
;	add.w dx(a5),a3
	add.w #(3<<8)/160,a3
	dbra d7,.xLoop
	
; incr imCoord
;	add.w dy(a5),a4
	add.w #(3<<8)/160,a4
	swap d7
	dbra d7,.yLoop
endproc ; drawMand

	code

proc PilotMain(cmd.w, cmdPBP.l, launchFlags.w)
; func args are equ'd as offsets from 'a6' reg
local err.w
local evt.EventType
local oldScreen.l
; and so are 'local's
beginproc
; ^ does 'link a6,#nnnn', for after args/locals
	tst.w cmd(a6)
	bne .Return ; sysAppLaunchCmdNormalLaunch is 0, else, quit

	move.l #dREG,a2

	or.b #$02,rLPICF|dREG
	move.b (dREG|rLVPW),d0
	lsl.b #2,d0
	move.b d0,(dREG|rLVPW)

	move.l dREG|rLSSA,oldScreen(a6)

	systrap MemPtrNew(#12800.l)
	; result in a0

	move.l a0,dREG|rLSSA          ; and set in hardware
;	systrap MemSet(a0.l,#12800.l,#$f0.b)

; memSet: (CLS)
	move.w #(160*80-1),d4
	move.b #$0f,d3
.l0
	move.b d3,(a0)+
	dbra d4,.l0

	bsr drawMand

.eventLoop
	systrap EvtGetEvent(&evt(a6), #evtWaitForever.w)
	systrap SysHandleEvent(&evt(a6))
	tst.b   d0                      ;handled?
	bne.s   .eventDone             ;yep

	nop ; can't branch to next instr

;        call    weHandleEvent(&evt(a6))
;        tst.b   d0                      ;handled?
;        bne.s   .eventDone             ;yep
.eventDone
	cmpi.w  #appStopEvent,evt+EventType.eType(a6) ;time to stop?
	bne.s   .eventLoop             ;nope, loop until it is

	and.b #$fc,rLPICF|dREG
	move.b (dREG|rLVPW),d0
	lsr.b #2,d0
	move.b d0,(dREG|rLVPW)

	move.l oldScreen(a6),dREG|rLSSA

.Return:
	moveq.l   #0,d0
endproc ; PilotMain

; Must have pref resources (otherwise 'fatal-error', on hotsync even!)
	res	'tver', 1
	dc.b	'1.0', 0

	res	'pref', 1
	dc.w	sysAppLaunchFlagNewStack|sysAppLaunchFlagNewGlobals|sysAppLaunchFlagUIApp|sysAppLaunchFlagSubCall
	dc.l	$1000			; stack size
	dc.l	$1000			; heap size


