; asmsyntax=asmM68k
; pix.asm  - putPixel routine w/ test, for monoch-pilots (dragon MC68EZ328)

	appl "pixTest",'demo'

	include "pilot.inc"
	include "startup.inc"

; TODO: hardware-reg equ file...
; LCD controller regs
rLPICF 	equ $A20
rLVPW  	equ $A05
rLSSA	equ $A00

dREG equ $FFFFF000 ; DragonBall regs

	code

; input: (d0,d1).w = x,y, d2, low-nibble = colour
; changes: d0-d3/a0
; side-effect: 4bpp Pixel is plot'd
putPixel:
	move.l dREG|rLSSA,a0 ; read screen pointer
	move.w d1,d3
	lsl.w #6,d3
	lsl.w #4,d1
	add.w d3,d1 ; = yoffset
	lea (a0,d1.w),a0
	lsr.w #1,d0
	lea (a0,d0.w),a0
	bcc .second
	andi.b #$f0,(a0)
	or.b d2,(a0)
	rts
.second
	andi.b #$0f,(a0)
	lsl.w #4,d2
	or.b d2,(a0)
	rts

proc PilotMain(cmd.w, cmdPBP.l, launchFlags.w)
; func args are equ'd as offsets from 'a6' reg
local err.w
local evt.EventType
local oldScreen.l
; and so are 'local's
beginproc
; ^ does 'link a6,#nnnn', for after args/locals
	tst.w cmd(a6)
	bne .Return ; sysAppLaunchCmdNormalLaunch is 0, else, quit

	move.l #dREG,a2

	or.b #$02,rLPICF|dREG
	move.b (dREG|rLVPW),d0
	lsl.b #2,d0
	move.b d0,(dREG|rLVPW)

	move.l dREG|rLSSA,oldScreen(a6)

	systrap MemPtrNew(#12800.l)
	; result in a0

	move.l a0,dREG|rLSSA          ; and set in hardware
;	systrap MemSet(a0.l,#12800.l,#$f0.b)

; memSet: (CLS)
	move.w #(160*80-1),d4
	move.b #$00,d3
.l0
	move.b d3,(a0)+
	dbra d4,.l0

.eventLoop
	systrap EvtGetEvent(&evt(a6), #evtWaitForever.w)
	systrap SysHandleEvent(&evt(a6))
	tst.b   d0                      ;handled?
	bne.s   .eventDone             ;yep

	call weHandleEvent(&evt(a6))

.eventDone
	cmpi.w  #appStopEvent,evt+EventType.eType(a6) ;time to stop?
	bne.s   .eventLoop             ;nope, loop until it is

	and.b #$fc,rLPICF|dREG
	move.b (dREG|rLVPW),d0
	lsr.b #2,d0
	move.b d0,(dREG|rLVPW)

	move.l oldScreen(a6),dREG|rLSSA

.Return:
	moveq.l   #0,d0
endproc ; PilotMain


proc weHandleEvent(pevt.l)
beginproc
	movea.l pevt(a6),a0             ;a0 = pevt
	cmpi.w  #keyDownEvent,EventType.eType(a0)
	bne  .notKey

	; handle keys:
	cmpi.w #pageDownChr,keyDown.chr(a0)
	bne .l0
	; handle keyDown
	;  ... todo ...
	bra .return
.l0
	cmpi.w #pageUpChr,keyDown.chr(a0)
	bne .notKey
	; handle keyUp todo
	bra .return

.notKey:
	cmpi.w  #penDownEvent,EventType.eType(a0)
	bne .l1
	bra .return

.l1
	cmpi.w #penUpEvent,EventType.eType(a0)
	bne .l2
	bra .return
.l2
	cmpi.w #penMoveEvent,EventType.eType(a0)
	bne .l3
	move.w EventType.screenX(a0),d0
	move.w EventType.screenY(a0),d1
	move.b #$0f,d2
	bsr putPixel
.l3
	; other events...

.return
endproc

; Must have pref resources (otherwise 'fatal-error', on hotsync even!)
	res	'tver', 1
	dc.b	'1.0', 0

	res	'pref', 1
	dc.w	sysAppLaunchFlagNewStack|sysAppLaunchFlagNewGlobals|sysAppLaunchFlagUIApp|sysAppLaunchFlagSubCall
	dc.l	$1000			; stack size
	dc.l	$1000			; heap size


